<?php

namespace Drupal\noahs_page_builder\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Access\AccessResult;
use Drupal\taxonomy\TermInterface;

/**
 * Controller routines for domain finder routes.
 */
class CheckAccessTermController extends ControllerBase {

  /**
   * Check access for the term.
   *
   * @param \Drupal\taxonomy\TermInterface $taxonomy_term
   *   The taxonomy term entity.
   *
   * @return \Drupal\Core\Access\AccessResult
   *   The access result.
   */
  public function checkAccess($taxonomy_term) {
    $noahs_page_builder_config = \Drupal::config('noahs_page_builder.settings');
    $use_in_vtype = $noahs_page_builder_config->get('use_in_vtype');

    return AccessResult::allowedIf(isset($use_in_vtype[$taxonomy_term->vid()]) && $taxonomy_term->vid() === $use_in_vtype[$taxonomy_term->vid()]);
  }

}
