<?php 

namespace Drupal\noahs_page_builder\Plugin\Control;

use Drupal\noahs_page_builder\Annotation\ControlPlugin;
use Drupal\noahs_page_builder\Plugin\Control\ControlBase;

/**
 * @ControlPlugin(
 *   id = "date",
 *   label = @Translation("Date")
 * )
 */

class ControlDate extends ControlBase{
	
	public function get_type() {
		return 'date';
	}

	public function content_template(array $params = []) {
		$data = $params['data'] ?? null;
    	$name = $params['name'] ?? null;
    	$value = $params['value'] ?? null;


		$output = '<div class="field_item">';
		$output .= '<label for="' . $data['item_id'] .'">' . $data['item']['title'] .'</label>';
		$output .= '<input type="date" name="' . $name .'" id="' . $data['item_id'] . '" title="' . $data['item']['title'] .'" class="form-control" value="'.$value.'" field-settings/>';
		$output .= '</div>';

		return $output;
	}

	public function render_control($data){
		return $this->base($data, $this->content_template($data));
	}

	public function get_default_settings() {
		return [
			'input_type' => 'date',
			'placeholder' => '',
			'title' => '',
		];
	}
}