<?php 

namespace Drupal\noahs_page_builder\Plugin\Control;

use Drupal\noahs_page_builder\Annotation\ControlPlugin;
use Drupal\noahs_page_builder\Plugin\Control\ControlBase;

/**
 * @ControlPlugin(
 *   id = "noahs_color",
 *   label = @Translation("Color")
 * )
 */

class ControlNoahsColor extends ControlBase{
	
	public function get_type() {
		return 'noahs_color';
	}

	public function content_template(array $params = []) {
		$data = $params['data'] ?? null;
    	$name = $params['name'] ?? null;
    	$value = $params['value'] ?? null;

		$placeholder = !empty($data['item']['placeholder']) ? $data['item']['placeholder']  : '';
		$output = '<div class="noahs_page_builder_field field__color">';
		$output .= '<input type="text" name="'.$name.'" id="' . $data['item_id'] . '" title="' . $data['item']['title'] .'" placeholder="'. $placeholder .'" value="' . $value . '" class="form-control-color"  field-settings/>';
		$output .= '</div>';

		return $output;
	}

	public function get_default_settings() {
		return [
			'input_type' => 'noahs_color',
			'placeholder' => '',
			'title' => '',
		];
	}
}