<?php 

namespace Drupal\noahs_page_builder\Plugin\Control;

use Drupal\noahs_page_builder\Annotation\ControlPlugin;
use Drupal\noahs_page_builder\Plugin\Control\ControlBase;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Drupal\noahs_page_builder\ModalForm;
use Drupal\file\Entity\File;
use Drupal\image\Entity\ImageStyle;

/**
 * @ControlPlugin(
 *   id = "noahs_coordinates",
 *   label = @Translation("Coordinates")
 * )
 */
class ControlNoahsCoordinates extends ControlBase {

	public function get_type() {
		return 'noahs_coordinates';
	}

	public function content_template(array $params = []) {
		$data = $params['data'] ?? null;
    	$name = $params['name'] ?? null;
    	$value = $params['value'] ?? null;
		$fields = $data['item']['fields'];
		$html = '';
	
		$html .= '<div class="nohas-field-description">Use your property as px, em, rem, %, ...</div>';
		$html .= '<ul class="field-element-list-horizontal">';
	
		foreach ($fields as $key => $field) {
			$final_value = htmlspecialchars($value[$key] ?? '', ENT_QUOTES, 'UTF-8');
			$field_title = htmlspecialchars($field['title'] ?? $key, ENT_QUOTES, 'UTF-8');
	
			$html .= '<li>';
			$html .= '<input type="text" name="' . htmlspecialchars($name) . '[' . htmlspecialchars($key) . ']" value="' . $final_value . '" class="form-control" field-settings>';
			$html .= '<label for="noahs_page_builder_coordinate_left">' . $field_title . '</label>';
			$html .= '</li>';
		}
	
		$html .= '</ul>';
	
		return $html;
	}
	

	public function get_default_settings() {
		return [
			'input_type' => 'noahs_coordinates',
			'title' => '',
		];
	}
}

